#!/bin/bash
export PATH=/bin:/sbin:/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/sbin:$PATH
: '
Copyright (C) 2022 - now HaoZi Technology Co., Ltd.
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published
by the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU Affero General Public License for more details.
You should have received a copy of the GNU Affero General Public License
along with this program. If not, see .
'
source <(curl -f -s --connect-timeout 10 --retry 3 https://dl.cdn.haozi.net/panel/public.sh)
if [ $? -ne 0 ]; then
echo "下载 public.sh 失败,请检查网络或稍后重试。"
echo "Download public.sh failed, please check the network or try again later."
exit 1
fi
channel=${1}
version=${2}
memcached_path="${setup_path}/server/memcached"
if ! id -u "memcached" >/dev/null 2>&1; then
groupadd memcached
useradd -s /sbin/nologin -g memcached memcached
fi
# 安装依赖
if [ ${OS} == "rhel" ]; then
dnf makecache -y
dnf groupinstall "Development Tools" -y
dnf install openssl-devel cyrus-sasl cyrus-sasl-devel libevent-devel -y
elif [ ${OS} == "debian" ] || [ ${OS} == "ubuntu" ]; then
apt-get update
apt-get install build-essential libssl-dev libsasl2-2 libsasl2-dev libevent-dev -y
else
error "不支持的操作系统"
fi
if [ "$?" != "0" ]; then
error "安装依赖软件失败"
fi
# 准备目录
rm -rf ${memcached_path}
mkdir -p ${memcached_path}
cd ${memcached_path}
# 下载源码
wget --retry-connrefused --retry-on-error -t 10 -T 120 -O ${memcached_path}/memcached-${version}.tar.gz ${download_url}/memcached/memcached-${version}.tar.gz
wget --retry-connrefused --retry-on-error -t 10 -T 120 -O ${memcached_path}/memcached-${version}.tar.gz.sha256 ${download_url}/memcached/memcached-${version}.tar.gz.sha256
if ! sha256sum --status -c memcached-${version}.tar.gz.sha256; then
rm -rf ${memcached_path}
error "memcached 校验失败"
fi
tar -zxvf memcached-${version}.tar.gz
rm -f memcached-${version}.tar.gz
rm -f memcached-${version}.tar.gz.sha256
mv memcached-${version} src
cd src
./configure --prefix=/www/server/memcached --enable-tls --enable-sasl --enable-sasl-pwdb --enable-64bit
if [ "$?" != "0" ]; then
rm -rf ${memcached_path}
error "memcached 配置失败"
fi
make -j${CORES}
if [ "$?" != "0" ]; then
rm -rf ${memcached_path}
error "memcached 编译失败"
fi
make install
if [ ! -f "${memcached_path}/bin/memcached" ]; then
rm -rf ${memcached_path}
error "memcached 安装失败"
fi
chown -R memcached:memcached ${memcached_path}
chmod -R 700 ${memcached_path}
# 设置服务
cat >/etc/systemd/system/memcached.service <